// Oleg Petruny proprietary.

#pragma once

#include "CoreMinimal.h"
#include "Engine/GameInstance.h"

#include "CustomGameInstanceBase.generated.h"

UCLASS()
class UCustomGameInstanceBase : public UGameInstance
{
    GENERATED_BODY()

public:
    virtual void Init() override;

    UFUNCTION(BlueprintCallable, Category = Settings)
    void ApplyMouseSettings();

    void AppendInteractableModificatorClass(TSubclassOf<class UInteractableModificator> modificator);

    UPROPERTY(EditDefaultsOnly)
    TSet<TSubclassOf<class UInteractableActivator>> interactionsActivators;
    TSet<TSubclassOf<class UInteractableModificator>> interactionsModificators;

    UPROPERTY(EditDefaultsOnly)
    TSet<TSoftObjectPtr<class UInputMappingContext>> inputContexts;

};
