// Oleg Petruny proprietary.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameModeBase.h"

#include "MainGameModeBase.generated.h"

UCLASS()
class AMainGameModeBase : public AGameModeBase
{
    GENERATED_BODY()

public:
    virtual void StartPlay() override;
    virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;
    virtual bool SetPause(APlayerController* PC, FCanUnpause CanUnpauseDelegate = FCanUnpause()) override;

    void SwitchCameraMode();

    UFUNCTION(BlueprintCallable)
    static class UWidgetsManager* GetWidgetsManager();
    UFUNCTION(BlueprintCallable)
    static class UCutsceneManager* GetCutsceneManager();

protected:
    UPROPERTY(EditDefaultsOnly)
    TSubclassOf<class UWidgetsManager> widgetManagerClass;

private:
    static class UWidgetsManager* _widgetsManager;
    static class UCutsceneManager* _cutsceneManager;
};
