// Oleg Petruny proprietary.


#include "InventoryWidget.h"

#include "Animation/WidgetAnimation.h"
#include "Engine/World.h"
#include "TimerManager.h"

void UInventoryWidget::Show()
{
    SetVisibility(ESlateVisibility::Visible);
    if(!showTimer.IsValid())
        PlayAnimation(showAnimation, GetAnimationCurrentTime(showAnimation), 1, EUMGSequencePlayMode::Forward, 1, false);
    GetWorld()->GetTimerManager().SetTimer(showTimer, this, &UInventoryWidget::Hide, showDuration, false);
}

void UInventoryWidget::Hide()
{
    PlayAnimation(showAnimation, GetAnimationCurrentTime(showAnimation), 1, EUMGSequencePlayMode::Reverse, 1, false);
    showTimer.Invalidate();
}
