// Oleg Petruny proprietary.

#pragma once

#include "InputAnimatedWidgetInterface.h"
#include "ResolutionResponsiveUserWidget.h"

#include "InventoryWidget.generated.h"

UCLASS(Blueprintable, Abstract)
class UInventoryWidget : public UResolutionResponsiveUserWidget, public IInputAnimatedWidgetInterface
{
    GENERATED_BODY()

public:
    void Show();

    UPROPERTY(meta = (BindWidget))
    class UTextBlock* firstItemKeyText;
    UPROPERTY(meta = (BindWidget))
    class UTextBlock* firstItemDescriptionText;
    UPROPERTY(meta = (BindWidget))
    class UTextBlock* secondItemKeyText;
    UPROPERTY(meta = (BindWidget))
    class UTextBlock* secondItemDescriptionText;
    UPROPERTY(Transient, meta = (BindWidgetAnim))
    class UWidgetAnimation* showAnimation;

protected:
    void Hide();

    UPROPERTY(EditDefaultsOnly, meta = (ClampMin = "1.0"))
    float showDuration = 2.0;

    FTimerHandle showTimer;
};
